Subject: Re: [PATCH iproute2-next] configure: Allow command line override of toolchain

From: Ido Schimmel <[email-masked]>
Date: Wed, 2 Mar 2022 15:56:15 +0200

On Sun, Feb 27, 2022 at 06:54:35PM -0700, David Ahern wrote:
> Easy way to build for both gcc and clang.
> 
> Signed-off-by: David Ahern <[email-masked]>
> ---
>  configure | 8 ++++----
>  1 file changed, 4 insertions(+), 4 deletions(-)
> 
> diff --git a/configure b/configure
> index 8ddff43c6a7d..13f2d1739b99 100755
> --- a/configure
> +++ b/configure
> @@ -19,10 +19,10 @@ check_toolchain()
>      : ${AR=ar}
>      : ${CC=gcc}
>      : ${YACC=bison}
> -    echo "PKG_CONFIG:=${PKG_CONFIG}" >>$CONFIG
> -    echo "AR:=${AR}" >>$CONFIG
> -    echo "CC:=${CC}" >>$CONFIG
> -    echo "YACC:=${YACC}" >>$CONFIG
> +    echo "PKG_CONFIG?=${PKG_CONFIG}" >>$CONFIG
> +    echo "AR?=${AR}" >>$CONFIG
> +    echo "CC?=${CC}" >>$CONFIG
> +    echo "YACC?=${YACC}" >>$CONFIG
>  }

David, are you sure this patch is needed? Even without it I can override
from the command line:

$ make V=1 CC=gcc

lib
make[1]: Entering directory '/home/idosch/code/iproute2/lib'
gcc -Wall -Wstrict-prototypes  -Wmissing-prototypes -Wmissing-declarations -Wold-style-definition -Wformat=2 -O2 -pipe -I../include -I../include/uapi -DRESOLVE_HOSTNAMES -DLIBDIR=\"/usr/lib\" -DCONFDIR=\"/etc/iproute2\" -DNETNS_RUN_DIR=\"/var/run/netns\" -DNETNS_ETC_DIR=\"/etc/netns\" -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -DHAVE_SETNS -DHAVE_HANDLE_AT -DHAVE_SELINUX -DHAVE_ELF -DHAVE_LIBMNL -DNEED_STRLCPY -DHAVE_LIBCAP -DHAVE_SETNS -DHAVE_HANDLE_AT -DHAVE_SELINUX -DHAVE_ELF -DHAVE_LIBMNL -DNEED_STRLCPY -DHAVE_LIBCAP -fPIC   -c -o libgenl.o libgenl.c
...

$ make V=1 CC=clang

lib
make[1]: Entering directory '/home/idosch/code/iproute2/lib'
clang -Wall -Wstrict-prototypes  -Wmissing-prototypes -Wmissing-declarations -Wold-style-definition -Wformat=2 -O2 -pipe -I../include -I../include/uapi -DRESOLVE_HOSTNAMES -DLIBDIR=\"/usr/lib\" -DCONFDIR=\"/etc/iproute2\" -DNETNS_RUN_DIR=\"/var/run/netns\" -DNETNS_ETC_DIR=\"/etc/netns\" -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -DHAVE_SETNS -DHAVE_HANDLE_AT -DHAVE_SELINUX -DHAVE_ELF -DHAVE_LIBMNL -DNEED_STRLCPY -DHAVE_LIBCAP -DHAVE_SETNS -DHAVE_HANDLE_AT -DHAVE_SELINUX -DHAVE_ELF -DHAVE_LIBMNL -DNEED_STRLCPY -DHAVE_LIBCAP -fPIC   -c -o libgenl.o libgenl.c

Also created this test file:

$ cat bla.mk
CC := foo

all:
        echo $(origin CC)
        echo $(CC)

$ make -f bla.mk
echo file
file
echo foo
foo

$ make -f bla.mk CC=clang
echo command line
command line
echo clang
clang

$ make -v
GNU Make 4.3
Built for x86_64-redhat-linux-gnu
Copyright (C) 1988-2020 Free Software Foundation, Inc.
License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>
This is free software: you are free to change and redistribute it.
There is NO WARRANTY, to the extent permitted by law.

I'm asking because this change broke the build on our Fedora machines
and my laptop. None of them have 'yacc' installed, but they do have
'bison', which was used unconditionally before the change. After the
change, 'YACC' is set to 'yacc', as it's an implicit variable that
defaults to 'yacc':

https://www.gnu.org/software/make/manual/html_node/Implicit-Variables.html